
package dev.sonpx.loyalty.mcp.enums;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import java.util.Arrays;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

/**
 * Created by SonPhung on Wednesday, 20-Dec-2023
 */
@Getter
@RequiredArgsConstructor
public enum EntityLevel {
    CUSTOMER("CU"),
    ACCOUNT("AC"),
    CARD("CA"),
    LOYALTY_ACCOUNT("LA");

    @JsonValue
    private final String code;

    @JsonCreator
    public static EntityLevel fromCode(String code) {
        return Arrays.stream(values())
                .filter(e -> e.code.equalsIgnoreCase(code))
                .findFirst()
                .orElse(null);
    }
}
